{
DMIDI
-----
(c)2006 S.V.Bulba
http://bulba.at.kz/
vorobey@mail.khstu.ru

Description:
------------
This is simple test program: playing MIDI files on the lowest level through
standard Win32 MIDI devices. Used Midi.pas (see also remarks there).
}

unit m1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MMSystem, Midi, ComCtrls, XPMan, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    ComboBox1: TComboBox;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    XPManifest1: TXPManifest;
    Timer1: TTimer;
    ScrollBar1: TScrollBar;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
 i:integer;
 tc:TIMECAPS;
begin
OpenDialog1.InitialDir := ExtractFileDir(ParamStr(0));

i := GetCurrentProcess;
SetPriorityClass(i,HIGH_PRIORITY_CLASS);
CloseHandle(i);

if timeGetDevCaps(@tc, sizeof(TIMECAPS)) = TIMERR_NOERROR then
 begin
  if PeriodMin < tc.wPeriodMin then PeriodMin := tc.wPeriodMin;
  if PeriodMin > tc.wPeriodMax then PeriodMin := tc.wPeriodMax;
 end;

CheckBox1.Checked := MIDILoop;

MIDIEnumDevices(ComboBox1);
			// Initialize all channels to unmuted
			for i := 0 to 15 do
				set_channel_mute(i, FALSE);
			// Initialize MT-32 state values
			init_mt32_state;

end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  StopMIDIThread;
	// If the MIDI-out interface is still open, close it
	if hout <> 0 then	close_midi_out;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin

//						if (ms.playing) then
	//						ms.stop_requested := True;
						// Get the filename from the user with the common open file dialog

if OpenDialog1.Execute then
 begin
  StopMIDIThread;
  load_midi(OpenDialog1.FileName);
  Button2Click(Sender)
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
						if not ms.playing and (ms.filename <> '') then
             begin
              StopMIDIThread;
              MIDIThreadH := CreateThread(nil,0,@MIDIThreadFunc,pointer(ComboBox1.ItemIndex - 1),0,MIDIThreadID)
             end 
						else
							if (ms.paused) then
								ms.paused := False;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
ms.paused := not ms.paused;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
StopMIDIThread;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const
 BAR_X = 240;
 BAR_WIDTH = 96;
 BAR_Y = 24;
 MAX_NOTE_HEIGHT = 20;
 r:TRect = (Left:BAR_X;Top:BAR_Y;Right:BAR_X+BAR_WIDTH;Bottom:BAR_Y+MAX_NOTE_HEIGHT+1);
var
 n:integer;
 dc:HDC;
 c:^channel_state_t;
 i,j,vol,note,x,y,h:integer;
 pen,oldpen:HPEN;
begin
if not ms.playing then exit;
if not ms.seek_sliding then
 begin
  n := trunc((ms.curtime - ms.starttime) / 1000.0);
  Form1.Label2.Caption := Format('%d:%02d', [n div 60, n mod 60]);
  ScrollBar1.Position := n;
 end;
// Update the graphical display

//	static int first = 1;
//	static HWND channel_hwnd[16];
//	static RECT channel_rect[16];
//	static int width, height;
//	int hdc_specified = 0;
//	int r, g, b, pb;

//	if (hdc)
//		hdc_specified = 1;
  dc := GetDC(Handle);
  FillRect(dc,r,COLOR_HIGHLIGHT + 1);

	// Loop through the MIDI channels
	for i := 0 to 15 do
	 begin
		c := @ms.channels[i];
		// Distinguish between channels with active notes versus silent channels
		if c.note_count <> 0 then
		 begin
			// This channel has at least one note playing.
			// Has anything been drawn for this channel?
(*			if (c.drawn)
			{
				// Yes, get rid of it!
				c->drawn = 0;
				// Update the channel background
				update_channel_background(hdc, i, c);
			}*)
			// Loop through the notes on this channel
			for j := 0 to 127 do
			 begin
				// Get the volume for this note (0 means the note is not being played)
				vol := c.notes[j];
				if vol <> 0 then
				 begin
					// This note is being played.  Figure out where in the bar it should
					// be drawn based on its note number (pitch).
					//
					// Since notes can range from 0 to 127 in pitch, but they're usually
					// not played at the extremes, I assume a note's pitch is from 24 to 96
					// when calculating its position.  If the calculated position is outside
					// the bar, the loop shifts it up or down by an octive until it's in range.
					note := j;
					repeat

						x := BAR_X + (note - 24) * BAR_WIDTH div (96 - 24);
						if (x > BAR_X + BAR_WIDTH - 1) then
							dec(note,12);
						if (x < BAR_X) then
							inc(note,12);

					until (x <= BAR_X + BAR_WIDTH - 1) and (x >= BAR_X);
					// Mark this channel as having something drawn for it.
//					c->drawn = 1;
					// Pick color based on instrument
(*					if (i == 9)
						r = g = b = 0;
					else
						hsv_to_rgb((float) c->normal_program * 360.0f / 128.0f, 1.0f, 1.0f, &r, &g, &b);
					// Darken the color and keep it within bounds
					r -= 64;
					if (r < 0)
						r = 0;
					g -= 64;
					if (g < 0)
						g = 0;
					b -= 64;
					if (b < 0)
						b = 0;*)
					// Create a pen for this color and select it into the DC
					oldpen := GetCurrentObject(dc, OBJ_PEN);
					pen := CreatePen(PS_SOLID, 1, GetSysColor(COLOR_HIGHLIGHTTEXT){RGB(r, g, b)});
					SelectObject(dc, pen);
					// Calculate the height of the bar
					h := MAX_NOTE_HEIGHT * vol div 127;
					// Calculate the top of the bar
					y := BAR_Y + 1 + (MAX_NOTE_HEIGHT - h);
					// Draw the note bar differently depending on whether or not this channel is being pitch-bended
					if True {(c.last_pitch_bend = 0) or (c.last_pitch_bend = -1)} then
					 begin
						// Draw a straight line going down
						MoveToEx(dc, x, y, nil);
						LineTo(dc, x, y + h);
					 end
					else
					 begin
(*					 	// Calculate the horizontal offset of the pitch bend
					 	if (ms.highest_pitch_bend)
							pb = (int) ((BAR_WIDTH / 10) * (float) c->last_pitch_bend / (float) ms.highest_pitch_bend);
						else
							pb = (int) ((BAR_WIDTH / 10) * (float) c->last_pitch_bend / MAX_PITCH_BEND);
						// Keep it within the boundaries of the bar
						if (x + pb >= BAR_X + BAR_WIDTH - 2)
							pb = BAR_X + BAR_WIDTH - x - 2;
						if (x + pb <= BAR_X)
							pb = BAR_X - x;
						// Draw a line going down half way to the center of the bar
						MoveToEx(hdc, x + pb, y, NULL);
						LineTo(hdc, x, y + h / 2);
						// Draw a line going down and out for the second half of the bar
						LineTo(hdc, x + pb, y + h);*)
					 end;
					// Select the old pen back into the DC and delete the temp color pen
					SelectObject(dc, oldpen);
					DeleteObject(pen);
				 end;
			 end;
		 end
		else
		 begin
			// The channel has no active notes.  Does it have anything drawn?
(*			if (c->drawn)
			{
				// Yes?  Clear it then, since nothing's playing now.
				if (!hdc)
					hdc = GetDC(hwndApp);
				c->drawn = 0;
				// Update the channel background
				update_channel_background(hdc, i, c);*)
     end;
   end;
ReleaseDC(Handle, dc);
end;


procedure TForm1.ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
if not ms.playing then exit;
case ScrollCode of
scEndScroll:
 begin
  ms.seek_sliding := False;
  if (not ms.seeking) then
   begin
    ms.seek_to := ScrollPos * 1000;
    ms.seeking := True;
   end;
 end;
scPosition,
scTrack:
 begin
  ms.seek_sliding := True;
	Label2.Caption := Format('%d:%02d', [ScrollPos div 60, ScrollPos mod 60]);
 end;
end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
MIDILoop := CheckBox1.Checked
end;

end.
