{
Ne midi
-------
(c)2006 S.V.Bulba
http://bulba.at.kz/
vorobey@mail.khstu.ru

Description:
------------
This is simple test program: playing MIDI files on the lowest level through
standard Win32 MIDI devices. Used Midi.pas (see also remarks there).
}

unit MainWindow;

interface

uses
  Windows, Messages, MMSystem, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, StdCtrls, XPMan;

type
  TFileTypes = (UnknownFile,MIDFile,RMIFile);
  TForm1 = class(TForm)
    Panel1: TPanel;
    PlayList: TListBox;
    AddButton: TSpeedButton;
    OpenDialog1: TOpenDialog;
    PlayButton: TSpeedButton;
    NextButton: TSpeedButton;
    PrevButton: TSpeedButton;
    StopButton: TSpeedButton;
    Bevel1: TBevel;
    ClearButton: TSpeedButton;
    PauseButton: TSpeedButton;
    ProgrBar: TScrollBar;
    CurTmLb: TLabel;
    TotTmLb: TLabel;
    Label3: TLabel;
    AboutButton: TSpeedButton;
    XPManifest1: TXPManifest;
    ComboBox1: TComboBox;
    CheckBox1: TCheckBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AddButtonClick(Sender: TObject);
    procedure PlayButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure PrevButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure PauseButtonClick(Sender: TObject);
    procedure AboutButtonClick(Sender: TObject);
    procedure PlayCurrent;
    function PlayNext:boolean;
    procedure WM_NEXT(var Msg: TMessage);message WM_USER;
    procedure FreeAllMIDI;
    procedure PlayListDblClick(Sender: TObject);
    procedure PlaySelected;
    procedure PlayListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TimePosTimerProc(Sender: TObject);
    procedure StartTimePosTimer;
    procedure StopTimePosTimer;
    procedure ProgrBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    function GetSongTitle:string;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
 MinFileType = Succ(Low(TFileTypes));
 MaxFileType = High(TFileTypes);
 FileTypes:array[MinFileType..MaxFileType] of string =
  ('.MID','.RMI');

var
  Form1: TForm1;
  CurrentItem:integer = -1;
  TimePosTimer:TTimer;
  TimerStarted:boolean = False;
  FileType:TFileTypes;

implementation

{$R *.DFM}

uses
 Midi;

function TimeSToStr(t:real):string;
var
 ms:integer;
begin
ms := round(t);
SetLength(Result,4);
Result[4] := char(ms mod 10 + 48);
ms := ms div 10;
Result[3] := char(ms mod 6 + 48);
ms := ms div 6;
Result[2] := ':';
Result[1] := char(ms mod 10 + 48);
ms := ms div 10;
if ms = 0 then exit;
Result := char(ms mod 6 + 48) + Result;
ms := ms div 6;
if ms = 0 then exit;
Result := IntToStr(ms) + ':' + Result
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FreeAllMIDI
end;

procedure TForm1.AboutButtonClick(Sender: TObject);
begin
Application.MessageBox('Ne midi'#13#10'Author is Sergey Bulba'#13#10 +
                       '(c)2006 S.V.Bulba'#13#10'http://bulba.at.kz/'#13#10 +
                       'vorobey@mail.khstu.ru','About program',MB_OK)
end;

procedure TForm1.AddButtonClick(Sender: TObject);
var
 i:integer;
begin
if OpenDialog1.Execute then
 begin
  OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
  for i := 0 to OpenDialog1.Files.Count - 1 do
   PlayList.Items.Add(OpenDialog1.Files.Strings[i])
 end
end;

procedure TForm1.PlayButtonClick(Sender: TObject);
begin
PlayCurrent
end;

procedure TForm1.NextButtonClick(Sender: TObject);
begin
PlayNext
end;

procedure TForm1.PrevButtonClick(Sender: TObject);
begin
if CurrentItem > 0 then
 begin
  Dec(CurrentItem);
  PlayCurrent
 end
end;

procedure TForm1.StopButtonClick(Sender: TObject);
begin
FreeAllMIDI
end;

procedure TForm1.ClearButtonClick(Sender: TObject);
begin
FreeAllMIDI;
PlayList.Clear;
CurrentItem := -1
end;

procedure TForm1.PauseButtonClick(Sender: TObject);
begin
if hout = 0 then exit;
ms.paused := not ms.paused;
if not ms.paused then
 PauseButton.Caption := 'Paus'
else
 PauseButton.Caption := 'Resu'
end;

function DetectFileType(FN:string):TFileTypes;
var
 i:TFileTypes;
begin
Result := UnknownFile;
FN := UpperCase(ExtractFileExt(FN));
for i := MinFileType to MaxFileType do
 if FileTypes[i] = FN then
  begin
   Result := i;
   exit
  end 
end;

procedure TForm1.PlayCurrent;
begin
if PlayList.Items.Count = 0 then exit;
StopTimePosTimer;
StopMIDIThread;
if CurrentItem = -1 then Inc(CurrentItem);
FileType := DetectFileType(PlayList.Items.Strings[CurrentItem]);
if not load_midi(PlayList.Items.Strings[CurrentItem]) then exit;
MIDIThreadH := CreateThread(nil,0,@MIDIThreadFunc,pointer(ComboBox1.ItemIndex - 1),0,MIDIThreadID);

//ProgrBar.Position := 0;
ProgrBar.Max := ms.song_length;
TotTmLb.Caption := TimeSToStr(ms.song_length);

StartTimePosTimer;
PlayList.ItemIndex := CurrentItem;
Caption := GetSongTitle;
PauseButton.Caption := 'Paus'
end;

function TForm1.PlayNext;
begin
Result := CurrentItem < PlayList.Items.Count - 1;
if Result then
 begin
  Inc(CurrentItem);
  PlayCurrent
 end
end;

procedure TForm1.WM_NEXT;
begin
ProgrBar.Position := ProgrBar.Max;
CurTmLb.Caption := TotTmLb.Caption;
if not PlayNext then FreeAllMIDI
end;

procedure TForm1.FreeAllMIDI;
begin
StopTimePosTimer;
StopMIDIThread;
if hout <> 0 then close_midi_out;
FileType := UnknownFile;
Caption := GetSongTitle
end;

procedure TForm1.PlayListDblClick(Sender: TObject);
begin
PlaySelected
end;

procedure TForm1.PlaySelected;
begin
if PlayList.ItemIndex >= 0 then
 begin
  CurrentItem := PlayList.ItemIndex;
  PlayCurrent
 end
end;

procedure TForm1.PlayListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_RETURN then PlaySelected
end;

procedure TForm1.TimePosTimerProc(Sender: TObject);
const
 BAR_X = 240;
 BAR_WIDTH = 96;
 BAR_Y = 72;
 MAX_NOTE_HEIGHT = 20;
 r:TRect = (Left:BAR_X;Top:BAR_Y;Right:BAR_X+BAR_WIDTH;Bottom:BAR_Y+MAX_NOTE_HEIGHT+1);
var
 dc:HDC;
 c:^channel_state_t;
 i,j,vol,cl,x,y,h:integer;
 pen,oldpen:HPEN;
begin
if hout = 0 then exit;
if not ms.playing then exit;
if not ms.seek_sliding and not ms.seeking then
 begin
  CurTmLb.Caption := TimeSToStr(ms.elapsedtime);
  ProgrBar.Position := ms.elapsedtime;
 end;
// Update the graphical display

  dc := GetDC(Panel1.Handle);
  FillRect(dc,r,COLOR_HIGHLIGHT + 1);

	// Loop through the MIDI channels
	for i := 0 to 15 do
	 begin
		c := @ms.channels[i];
		// Distinguish between channels with active notes versus silent channels
		if c.note_count <> 0 then
		 begin
			// This channel has at least one note playing.
			// Loop through the notes on this channel
			for j := 16 to 127 do
			 begin
				// Get the volume for this note (0 means the note is not being played)
				vol := c.notes[j];
				if vol <> 0 then
				 begin
					// This note is being played.  Figure out where in the bar it should
					// be drawn based on its note number (pitch).

					// Calculate the height of the bar
					h := MAX_NOTE_HEIGHT * vol div 127;
					// Calculate the top of the bar
					y := BAR_Y + 1 + (MAX_NOTE_HEIGHT - h);

          //0 - 8.1757 Hz
          //12 - 16.3516 Hz
          //16 - 20.6017 Hz
          //100 - 2637.0205 Hz
          //127 - 12543.8540 Hz
					// Draw the note bar differently depending on whether or not this channel is being pitch-bended
					if c.last_pitch_bend = 0 then
           begin
            x := BAR_X + (j - 16) * (BAR_WIDTH - 1) div (127 - 16);
            cl := GetSysColor(COLOR_HIGHLIGHTTEXT)
           end
					else
					 begin
            //Due http://www.elvenminstrel.com/music/tuning/reference/pitchbends.shtml
            //one unit of MIDI pitch bend is 2/8192 of semitones
            x := BAR_X + round((j - 16 + c.last_pitch_bend * (2 / 8192)) * (BAR_WIDTH - 1) / (127 - 16));
            cl := GetSysColor(COLOR_GRAYTEXT)
					 end;
 					// Create a pen for this color and select it into the DC
					oldpen := GetCurrentObject(dc, OBJ_PEN);
  				pen := CreatePen(PS_SOLID, 1, cl);
  				SelectObject(dc, pen);
					// Draw a straight line going down
					MoveToEx(dc, x, y, nil);
					LineTo(dc, x, y + h);
					// Select the old pen back into the DC and delete the temp color pen
					SelectObject(dc, oldpen);
					DeleteObject(pen);
				 end;
			 end;
		 end
   end;
ReleaseDC(Panel1.Handle, dc);
end;

procedure TForm1.StartTimePosTimer;
begin
if TimerStarted then exit;
ProgrBar.Position := 0;
CurTmLb.Caption := '0:00';
TimePosTimer := TTimer.Create(Self);
TimePosTimer.Interval := 40;
TimePosTimer.OnTimer := TimePosTimerProc;
TimerStarted := True
end;

procedure TForm1.StopTimePosTimer;
begin
if not TimerStarted then exit;
TimePosTimer.Free;
TimerStarted := False
end;

procedure TForm1.ProgrBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
if hout = 0 then exit;
if not ms.playing then exit;
case ScrollCode of
scPosition,scTrack:
 begin
  ms.seek_sliding := True;
	CurTmLb.Caption := TimeSToStr(ScrollPos);
 end;
scEndScroll:
 begin
  ms.seek_sliding := False;
  if (not ms.seeking) then
   begin
    ms.seek_to := ScrollPos * 1000;
    ms.seeking := True;
   end;
 end
end 
end;

function RemoveStdExt(Ext:TFileTypes;FileName:string):string;
var
 SExt:string;
 i:integer;
begin
FileName := ExtractFileName(FileName);
SExt := Trim(FileName);
i := Length(SExt);
while (i > 1) and (SExt[i] <> '.') do Dec(i);
if i = 1 then
 begin
  Result := FileName;
  exit
 end;
SExt := UpperCase(Copy(SExt,i,Length(SExt) - i + 1));
if FileTypes[Ext] = SExt then
 Result := Copy(FileName,1,i - 1)
else
 Result := FileName
end;

function FormatTitle(Author,Title:string):string;
begin
if (Author <> '') and (Title <> '') then
 Result := Author + ' - ' + Title
else if Author <> '' then
 Result := Author
else if Title <> '' then
 Result := Title
else
 Result := ''
end;

function TForm1.GetSongTitle;
var
 p:Pmidi_text_t;
 a,t,s:string;
begin
if (FileType = UnknownFile) or (CurrentItem < 0) then
 Result := 'Ne midi'
else
 begin

  t := '';
  p := midi_text_events;
  while p <> nil do
   begin
    //Sequence or track name
    s := Trim(p.midi_text);
    if (p.text_type = 3) and (s <> '') then
     begin
      t := s;
      break
     end;
    p := p.next
   end;

  a := '';
  p := midi_text_events;
  while p <> nil do
   begin
    //Copyright text
    s := Trim(p.midi_text);
    if (p.text_type = 2) and (s <> '') then
     begin
      a := s;
      break
     end;
    p := p.next
   end;

  Result := FormatTitle(a,t);

  if Result = '' then
   Result := RemoveStdExt(FileType,PlayList.Items.Strings[CurrentItem])
 end
end;

procedure TForm1.FormCreate(Sender: TObject);
var
 i:integer;
 tc:TIMECAPS;
begin
//OpenDialog1.InitialDir := ExtractFileDir(ParamStr(0));

i := GetCurrentProcess;
SetPriorityClass(i,HIGH_PRIORITY_CLASS);
CloseHandle(i);

if timeGetDevCaps(@tc, sizeof(TIMECAPS)) = TIMERR_NOERROR then
 begin
  if PeriodMin < tc.wPeriodMin then PeriodMin := tc.wPeriodMin;
  if PeriodMin > tc.wPeriodMax then PeriodMin := tc.wPeriodMax;
 end;

CheckBox1.Checked := MIDILoop;

hwndApp := Handle;

MIDIEnumDevices(ComboBox1);
mh.num_tracks := 0;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
MIDILoop := CheckBox1.Checked
end;

end.
